config/routes.rb
Rails.application.routes.draw do
  root "authorities#index"
  devise_for :users, controllers: {
    sessions: 'users/sessions',
    passwords: 'users/passwords'
  }
  
  resources :authorities
  resources :basic_informations
  resources :infrastructures
  resources :events
  resources :departments do
    collection do
      get :get_subjects
    end
  end
end

app/models/infrastructure.rb
class Infrastructure < ApplicationRecord
	require 'csv'
	validates :campus, presence: true
	has_many :hostels, dependent: :destroy
	has_many :libraries, dependent: :destroy
	has_many :ict_infrastructures, dependent: :destroy

	enum campus: {"main campus": 0, "constituent college": 1, "off campus": 2, "out reach": 3}
	
	accepts_nested_attributes_for :hostels, reject_if: :all_blank, allow_destroy: true
	accepts_nested_attributes_for :libraries, reject_if: :all_blank, allow_destroy: true
	accepts_nested_attributes_for :ict_infrastructures, reject_if: :all_blank, allow_destroy: true

	def self.to_csv(infrastructures)
    #headers = ["Name", "Campus", "Land Availability (in acres)", "No of Classes", "No of Labs", "Hostel Name", "Hostel Type", "Total Boys", "Total Girls", "Library Name", "Total Books", "Total E-books", "Total Journals", "Total E-journals", "ICT Type", "Availability", "No of ICT Enabled Classes", "Speed", "Service Provide", "Bandwidth"]
     headers = ["Name", "Campus", "Land Availability (in acres)", "No of Classes", "No of Labs"]
    CSV.generate(headers: true) do |csv|
      csv << headers
      if infrastructures.present?
        infrastructures.each do |infra|
        	# hostels_attributes = []
   				# if infra.hostels.present?
   				# 	infra.hostels.each do |h|
   				# 		hostels_attributes << [
   				# 			h.name,
   				# 			h.hostel_type,
   				# 			h.total_boys,
   				# 			h.total_girls
   				# 		].flatten
   				# 	end
   				# end

   				# libraries_attributes = []
   				# if infra.libraries.present?
   				# 	infra.libraries.each do |l|
   				# 		hostels_attributes << [
   				# 			l.name,
   				# 			l.total_books,
   				# 			l.total_ebooks,
   				# 			l.total_journals,
   				# 			l.total_ejournals,
   				# 		].flatten
   				# 	end
   				# end

   				# ict_attributes = []
   				# if infra.ict_infrastructures.present?
   				# 	infra.ict_infrastructures.each do |i|
   				# 		hostels_attributes << [
   				# 			i.ict_type,
   				# 			i.availability,
   				# 			i.no_of_ict_enabled_classes,
   				# 			i.speed,
   				# 			i.service_provider,
   				# 			i.bandwidth
   				# 		].flatten
   				# 	end
   				# end

          csv << [
            infra.name,
            infra.campus,
            infra.land_availability,
            infra.no_of_classes,
            infra.no_of_labs
          ].flatten
        end

      end
    end
  end 

end

app/controllers/infrastructures_controller.rb
class InfrastructuresController < ApplicationController
  before_action :set_infrastructure, only: %i[ show edit update destroy ]

  def index
    @infrastructures = Infrastructure.order(campus: :asc)
    respond_to do |format|
      format.html
      format.js
      format.csv { send_data Infrastructure.to_csv(@infrastructures), filename: "infrastructure.csv" }
    end
  end

  def show
  end

  def new
    @infrastructure = Infrastructure.new
    2.times { @infrastructure.hostels.build }
  end

  def edit
  end

  def create
    @infrastructure = Infrastructure.new(infrastructure_params)
    respond_to do |format|
      if @infrastructure.save
        format.html { redirect_to infrastructures_url, notice: "Infrastructure was successfully created." }
        format.json { render :show, status: :created, location: @infrastructure }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @infrastructure.errors, status: :unprocessable_entity }
      end
    end
  end

  def update
    respond_to do |format|
      if @infrastructure.update(infrastructure_params)
        format.html { redirect_to infrastructures_url, notice: "Infrastructure was successfully updated." }
        format.json { render :show, status: :ok, location: @infrastructure }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @infrastructure.errors, status: :unprocessable_entity }
      end
    end
  end

  def destroy
    @infrastructure.destroy
    respond_to do |format|
      format.html { redirect_to infrastructures_url, notice: "Infrastructure was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_infrastructure
      @infrastructure = Infrastructure.find_by(id: params[:id])
    end

    # Only allow a list of trusted parameters through.
    def infrastructure_params
      params.require(:infrastructure).permit(:name, :campus, :land_availability, :no_of_classes, :no_of_labs,
        hostels_attributes: [:id, :hostel_type, :name,
            :total_boys, :total_girls, :_destroy],
        libraries_attributes: [:id, :name,
            :total_books, :total_ebooks, :total_journals, :total_ejournals, :_destroy],
        ict_infrastructures_attributes: [:id, :ict_type, :availability, :no_of_ict_enabled_classes, :speed, :service_provider, :bandwidth, :_destroy]
      )
    end
end

app/helpers/infrastructures_helper.rb
module InfrastructuresHelper
	def campus_collection
		[
			["Main Campus", "main campus"],
			["Constituent College", "constituent college"],
			["Off Campus", "off campus"],
			["Out Reach", "out reach"]
		]
	end

	def hostel_type_collection
		[
			["Boy's Hostel", "boy's hostel"],
			["Girl's Hostel", "girl's hostel"]
		]
	end

	def ict_type_collection
		[
			["WiFi", "wifi"],
			["Broadband", "broadband"]
		]
	end

	def availability_collection
		[
			["Teachers", "teachers"],
			["Students", "students"],
			["Both", "both"]
		]
	end

end

app/views/infrastructures/_form.html.erb
<div class="shadow-box mb-5">
  <%= simple_form_for @infrastructure, html: {class: "mt-4"} do |f| %>
    <%= f.error_notification %>
    <div class="row">
      <div class="col-md-3">
        <%= f.input :campus, label: "CAMPUS", collection: campus_collection, input_html: {class: "form-control form-flied"} %>
      </div>
      <div class="col-md-3">
        <%= f.input :name, label: "NAME", input_html: { class: "form-control form-flied" } %>
      </div>
      <div class="col-md-3">
        <%= f.input :land_availability, label: "LAND AVAILABILITY (IN ACRES)", input_html: {class: "form-control form-flied"} %>
      </div>
      <div class="col-md-3">
        <%= f.input :no_of_classes, label: "NO OF CLASSES", input_html: {class: "form-control form-flied"} %>
      </div>
      <div class="col-md-3">
        <%= f.input :no_of_labs, label: "NO OF LABS", input_html: {class: "form-control form-flied"} %>
      </div>
    </div>

    <hr>
    <div class="sub-head my-4">Hostel</div>
    <%= f.simple_fields_for :hostels do |hostel| %>
      <%= render 'hostel_fields', :f => hostel %>
    <% end %>

    <hr>
    <div class="sub-head my-4">Library</div>
    <%= f.simple_fields_for :libraries do |library| %>
      <%= render 'library_fields', :f => library %>
    <% end %>
    <div class='links'>
      <%= link_to_add_association 'ADD LIBRARY', f, :libraries, class: "btn-success btn rounded-2 btn-sm" %>
    </div>

    <hr>
    <div class="sub-head my-4">ICT Infrastructure</div>
    <%= f.simple_fields_for :ict_infrastructures do |ict_infrastructure| %>
      <%= render 'ict_infrastructure_fields', :f => ict_infrastructure %>
    <% end %>
    <div class='links'>
      <%= link_to_add_association 'ADD ICT INFRASTRUCTURE', f, :ict_infrastructures, class: "btn-success btn rounded-2 btn-sm mb-3" %>
    </div>

    <div class="form-actions">
      <%= f.button :submit, "SAVE", class: "btn btn-primary btn-blue" %>
    </div>
  <% end %>
</div>

app/views/infrastructures/_hostel_fields.html.erb
<div class="row nested-fields">
  <div class="col-md-3">
    <%= f.input :hostel_type, label: "HOSTEL TYPE", collection: hostel_type_collection, input_html: {class: "form-control form-flied hostel_select"} %>
  </div>
  <div class="col-md-3">
    <%= f.input :name, label: "NAME", input_html: { class: "form-control form-flied" } %>
  </div>
  <div class="col-md-3 boys_div">
    <%= f.input :total_boys, label: "TOTAL BOYS", input_html: { class: "form-control form-flied boys_div" } %>
  </div>
  <div class="col-md-3 girls_div">
    <%= f.input :total_girls, label: "TOTAL GIRLS", input_html: { class: "form-control form-flied" } %>
  </div>
</div>
<%= link_to_remove_association 'REMOVE HOSTEL', f, class: "btn-danger btn rounded-2 btn-sm mb-3 mt-2" %>

<script type="text/javascript">
  $(document).ready(function(){
    var type = $('#infrastructure_hostels_attributes_0_hostel_type').find('option:selected').text();
    if (type == "Boy's Hostel") {
      $('label[for=infrastructure_hostels_attributes_0_total_boys], input#infrastructure_hostels_attributes_0_total_boys').show();
      $('label[for=infrastructure_hostels_attributes_0_total_girls], input#infrastructure_hostels_attributes_0_total_girls').hide();
    }else if(type == "Girl's Hostel"){
      $('label[for=infrastructure_hostels_attributes_0_total_girls], input#infrastructure_hostels_attributes_0_total_girls').show();
      $('label[for=infrastructure_hostels_attributes_0_total_boys], input#infrastructure_hostels_attributes_0_total_boys').hide();
    }else{
      $('label[for=infrastructure_hostels_attributes_0_total_boys], input#infrastructure_hostels_attributes_0_total_boys').show();
      $('label[for=infrastructure_hostels_attributes_0_total_girls], input#infrastructure_hostels_attributes_0_total_girls').show();
    }

    var type = $('#infrastructure_hostels_attributes_1_hostel_type').find('option:selected').text();
    if (type == "Boy's Hostel") {
      $('label[for=infrastructure_hostels_attributes_1_total_boys], input#infrastructure_hostels_attributes_1_total_boys').show();
      $('label[for=infrastructure_hostels_attributes_1_total_girls], input#infrastructure_hostels_attributes_1_total_girls').hide();
    }else if(type == "Girl's Hostel"){
      $('label[for=infrastructure_hostels_attributes_1_total_girls], input#infrastructure_hostels_attributes_1_total_girls').show();
      $('label[for=infrastructure_hostels_attributes_1_total_boys], input#infrastructure_hostels_attributes_1_total_boys').hide();
    }else{
      $('label[for=infrastructure_hostels_attributes_1_total_boys], input#infrastructure_hostels_attributes_1_total_boys').show();
      $('label[for=infrastructure_hostels_attributes_1_total_girls], input#infrastructure_hostels_attributes_1_total_girls').show();
    }
  });

  $('#infrastructure_hostels_attributes_0_hostel_type').on('change', function(){
    var type = $(this).find('option:selected').text();
    if (type == "Boy's Hostel") {
      $('label[for=infrastructure_hostels_attributes_0_total_boys], input#infrastructure_hostels_attributes_0_total_boys').show();
      $('label[for=infrastructure_hostels_attributes_0_total_girls], input#infrastructure_hostels_attributes_0_total_girls').hide();
    }else if(type == "Girl's Hostel"){
      $('label[for=infrastructure_hostels_attributes_0_total_girls], input#infrastructure_hostels_attributes_0_total_girls').show();
      $('label[for=infrastructure_hostels_attributes_0_total_boys], input#infrastructure_hostels_attributes_0_total_boys').hide();
    }else{
      $('label[for=infrastructure_hostels_attributes_0_total_boys], input#infrastructure_hostels_attributes_0_total_boys').show();
      $('label[for=infrastructure_hostels_attributes_0_total_girls], input#infrastructure_hostels_attributes_0_total_girls').show();
    }
  });

  $('#infrastructure_hostels_attributes_1_hostel_type').on('change', function(){
    var type = $(this).find('option:selected').text();
    if (type == "Boy's Hostel") {
      $('label[for=infrastructure_hostels_attributes_1_total_boys], input#infrastructure_hostels_attributes_1_total_boys').show();
      $('label[for=infrastructure_hostels_attributes_1_total_girls], input#infrastructure_hostels_attributes_1_total_girls').hide();
    }else if(type == "Girl's Hostel"){
      $('label[for=infrastructure_hostels_attributes_1_total_girls], input#infrastructure_hostels_attributes_1_total_girls').show();
      $('label[for=infrastructure_hostels_attributes_1_total_boys], input#infrastructure_hostels_attributes_1_total_boys').hide();
    }else{
      $('label[for=infrastructure_hostels_attributes_1_total_boys], input#infrastructure_hostels_attributes_1_total_boys').show();
      $('label[for=infrastructure_hostels_attributes_1_total_girls], input#infrastructure_hostels_attributes_1_total_girls').show();
    }
  });
</script>

app/views/infrastructures/_hostel_table.html.erb
<table class="table table-striped table-borderless table-custom">
  <thead class="table-purple">
    <tr>
      <th scope="col">Type</th>
      <th scope="col">Name</th>
      <th scope="col">Total Boys</th>
      <th scope="col">Total Girls</th>
    </tr>
  </thead>
  <tbody>
    <% infrastructure.hostels.each do |hostel| %>
      <tr>
        <td><%= hostel.hostel_type %></td>
        <td><%= hostel.name %></td>
        <td><%= hostel.total_boys %></td>
        <td><%= hostel.total_girls %></td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/infrastructures/_ict_infrastructure_fields.html.erb
<div class="nested-fields row">
  <div class="col-md-3">
    <%= f.input :ict_type, label: "TYPE", collection: ict_type_collection, input_html: {class: "form-control form-flied"} %>
  </div>
  <div class="col-md-3">
    <%= f.input :availability, label: "AVAILABILITY", collection: availability_collection, input_html: {class: "form-control form-flied"} %>
  </div>
  <div class="col-md-3">
    <%= f.input :no_of_ict_enabled_classes, label: "NO OF ICT ENABLED CLASSES", input_html: { class: "form-control form-flied" } %>
  </div>
  <div class="col-md-3">
    <%= f.input :speed, label: "SPEED (MBPS)", input_html: { class: "form-control form-flied" } %>
  </div>
  <div class="col-md-3">
    <%= f.input :service_provider, label: "SERVICE PROVIDER", input_html: { class: "form-control form-flied" } %>
  </div>
  <div class="col-md-3">
    <%= f.input :bandwidth, label: "BANDWIDTH", input_html: { class: "form-control form-flied" } %>
  </div>
</div>
<%= link_to_remove_association 'REMOVE ICT INFRASTRUCTURE', f, class: "btn-danger btn rounded-2 btn-sm mb-3 mt-2" %>

app/views/infrastructures/_ict_table.html.erb
<table class="table table-striped table-borderless table-custom">
  <thead class="table-purple">
    <tr>
      <th scope="col">Type</th>
      <th scope="col">Available</th>
      <th scope="col">ICT Enabled Classes</th>
      <th scope="col">Speed</th>
      <th scope="col">Service Provider</th>
      <th scope="col">Service Provider</th>
    </tr>
  </thead>
  <tbody>
    <% infrastructure.ict_infrastructures.each do |ict| %>
      <tr>
        <td><%= ict.ict_type %></td>
        <td><%= ict.availability %></td>
        <td><%= ict.no_of_ict_enabled_classes %></td>
        <td><%= ict.speed %></td>
        <td><%= ict.service_provider %></td>
        <td><%= ict.bandwidth %></td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/infrastructures/_infra_details_table.html.erb
<table class="table table-striped table-borderless table-custom">
  <thead class="table-purple">
    <tr>
      <th scope="col">Name</th>
      <th scope="col">Campus</th>
      <th scope="col">Land Availability (in acres)</th>
      <th scope="col">No of Classes</th>
      <th scope="col">No of Labs</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <td><%= infrastructure.name %></td>
      <td><%= infrastructure.campus %></td>
      <td><%= infrastructure.land_availability %></td>
      <td><%= infrastructure.no_of_classes %></td>
      <td><%= infrastructure.no_of_labs %></td>
    </tr>
  </tbody>
</table>

app/views/infrastructures/_library_fields.html.erb
<div class="nested-fields row">
  <div class="col-md-3">
    <%= f.input :name, label: "NAME", input_html: { class: "form-control form-flied" } %>
  </div>
  <div class="col-md-3">
    <%= f.input :total_books, label: "TOTAL BOOKS", input_html: { class: "form-control form-flied" } %>
  </div>
  <div class="col-md-3">
    <%= f.input :total_ebooks, label: "TOTAL E-BOOKS", input_html: { class: "form-control form-flied" } %>
  </div>
  <div class="col-md-3">
    <%= f.input :total_journals, label: "TOTAL JOURNALS", input_html: { class: "form-control form-flied" } %>
  </div>
  <div class="col-md-3">
    <%= f.input :total_ejournals, label: "TOTAL E-JOURNALS", input_html: { class: "form-control form-flied" } %>
  </div>
</div>
<%= link_to_remove_association 'REMOVE LIBRARY', f, class: "btn-danger btn rounded-2 btn-sm mb-3 mt-2" %>

app/views/infrastructures/_library_table.html.erb
<table class="table table-striped table-borderless table-custom">
  <thead class="table-purple">
    <tr>
      <th scope="col">Name</th>
      <th scope="col">Total Books</th>
      <th scope="col">Total Ebooks</th>
      <th scope="col">Total Journals</th>
      <th scope="col">Total Ejournals</th>
    </tr>
  </thead>
  <tbody>
    <% infrastructure.libraries.each do |library| %>
      <tr>
        <td><%= library.name %></td>
        <td><%= library.total_books %></td>
        <td><%= library.total_ebooks %></td>
        <td><%= library.total_journals %></td>
        <td><%= library.total_ejournals %></td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/infrastructures/edit.html.erb
<div class="mt-5">
	<%= link_to image_tag("back.svg", class: "pr-2 me-2")+"Infrastructure >", infrastructures_path, class: "page-head" %>
	<%= link_to "Edit Infrastructure", "javascript:void(0)", class: "page-head-in" %>
</div>
<%= render "form", infrastructure: @infrastructure %>

app/views/infrastructures/index.html.erb
<div class="d-flex justify-content-between mt-5">
  <div class="sub-head">Infrastructure List</div>
  <%= link_to 'Download CSV', infrastructures_path(format: "csv"), class: 'btn btn-primary btn-blue'%>
</div>
<div class="d-flex justify-content-between mt-2">
  <div class="sub-head"></div>
  <%= link_to "Add", new_infrastructure_path, class: "btn btn-primary btn-blue" %>
</div>

<div class="table-responsive mt-5">
  <table class="table table-striped table-borderless table-custom">
    <thead class="table-purple">
      <tr>
        <th scope="col">Infrastructure Details</th>
        <th scope="col">Hostel Details</th>
        <th scope="col">Library Details</th>
        <th scope="col">ICT Infrastructure</th>
        <th scope="col">Actions</th>
      </tr>
    </thead>
    <tbody>
      <% @infrastructures.each do |infrastructure| %>
        <tr>
          <td>
            <%= render 'infra_details_table', :infrastructure => infrastructure %>
          </td>
          <td>
            <%= render 'hostel_table', :infrastructure => infrastructure %>
          </td>
          <td>
            <%= render 'library_table', :infrastructure => infrastructure %>
          </td>
          <td>
            <%= render 'ict_table', :infrastructure => infrastructure %>
          </td>
          <td>
            <%= link_to image_tag("edit.svg", class: "btn btn-bg btn-edit"), edit_infrastructure_path(infrastructure) %>
            <%= link_to image_tag("delete.svg", class: "btn btn-bg"), infrastructure_path(infrastructure), data: { turbo_method: :delete, confirm: 'Are you sure?' } %>
          </td>
        </tr>
      <% end %>
    </tbody>
  </table>
</div>

app/views/infrastructures/new.html.erb
<div class="mt-5">
	<%= link_to image_tag("back.svg", class: "pr-2 me-2")+"Infrastructure >", infrastructures_path, class: "page-head" %>
	<%= link_to "New Infrastructure", "javascript:void(0)", class: "page-head-in" %>
</div>
<%= render "form", infrastructure: @infrastructure %>